<div id="tree">

</div>
 <script type="module">
import { Tree } from "/js/Tree/Tree.js";
import { Module } from "/js/client.js";




//=========================================================
export class FunctionModule extends Module {
//=========================================================

    //-----------------------------------------------------
    constructor(client,id) {
    //-----------------------------------------------------
        super(client,id);
        this.id = id;

this.root().tree();
    }
    //-----------------------------------------------------
    update() {
    //-----------------------------------------------------
       console.log(this.parent.selected);
       var data=this.onRequest();
       console.log("send",data);
       this.parent.ask_json(data,this.onDo.bind(this));
        return false;
    }
    //-----------------------------------------------------
    onRequest() {
    //-----------------------------------------------------

        var data = {};
        data["action"]="tree";
        //data["select"]=this.selected;
        return data;
    }
    //-----------------------------------------------------
    onDo(data) {
    //-----------------------------------------------------
       console.log("result",data.response);

        var string="";

        for (const elt of data.response.parents) {
              string += "<div class='tree'>"+this.make_node(elt);
        }
        string += "<div class='tree selected'>"+this.make_node(data.response);
        for (const elt of data.response.children) {
              string += "<div class='tree'>"+this.make_node(elt)+"</div>";
        }
        string +="</div>" ;
        for (const elt of data.response.parents) {
              string += "</div>";
        }

        $("#"+this.id).html(string);
    }
    //-----------------------------------------------------
    make_node(elt) {
    //-----------------------------------------------------
        return `<p onclick="document.app.selected='${elt.path}';document.app.search_path('tree').update();">${elt.name}</p>`;
    }
    //-----------------------------------------------------

}
//=========================================================
var tree=new FunctionModule(document.app,"tree");
tree.update();
</script> 
